%{
#include "scheme_interp.h"
#include "scheme.yacc.tab.h"
#include "string.h"
char *copy_string(char *s)
{
  int i, l;
  char *res;
  
  l = strlen(s);
  res = (char*)ALLOC(sizeof(char) * (l + 1));
  for (i = 0; i < l; ++i)
    res[i] = s[i];
  res[l] = NULL;
  return res;
}
%}

START_LETTER [a-zA-Z!$%&*/:<=>?^_~]
NEXT_LETTER [a-zA-Z0-9!$%&*/:<=>?^_~+-.@]

%%

[ \n\t]+
"null" return NLL;
"#f" return HASHF;
"void" return VOID;
"lambda" return LAMBDA;
"let" return LET;
"letrec" return LETREC;
"if" return IF;
"begin" return BGIN;
"set!" return SET;
"and" return AND;
"or" return OR;
"not" return NOT;
{START_LETTER}{NEXT_LETTER}* yylval.str = copy_string(yytext); return ID;
"+" yylval.str = copy_string(yytext); return ID;
"-" yylval.str = copy_string(yytext); return ID;
"..." yylval.str = copy_string(yytext); return ID;
[-+]?[0-9]+ yylval.num = atoi(yytext); return NUM;
. return yytext[0];
%%
