#include "scheme_interp.h"

/* Memory Heap */
unsigned char *alloc_ptr;
unsigned char *alloc_limit;
unsigned char *heap;
static unsigned char *alternate;

void memory_init(heap_val ***roots, int num_roots)
{
  heap = (unsigned char*)malloc(BYTES);
  alternate = (unsigned char*)malloc(BYTES);
  alloc_ptr = heap;
  alloc_limit = alloc_ptr + BYTES;

  /* Initialize the constants */
  false_const = (val*)allocate(sizeof(false_val));
  false_const->tag = FALSE_VAL;
  zero_const = (val*)allocate(sizeof(number_val));
  zero_const->tag = NUMBER_VAL;
  ((number_val*)zero_const)->n = 0;
  void_const = (val*)allocate(sizeof(void_val));
  void_const->tag = VOID_VAL;
  null_const = (val*)allocate(sizeof(null_val));
  null_const->tag = NULL_VAL;
}

unsigned char *allocate(int bytes)
{
  unsigned char *old;
  if (alloc_ptr + bytes > alloc_limit)
  {
    printf("Out of memory\n");
    exit(2);
  }
  old = alloc_ptr;
  alloc_ptr = alloc_ptr + bytes;
  return old;
}
